#include <sstream>
#include <iomanip>
#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <string>
#include <deque>
#include <complex>

#define FOR(i,a,b) for(int i=(a),_b=(b); i<=_b; i++)
#define FORD(i,a,b) for(int i=(a),_b=(b); i>=_b; i--)
#define REP(i,a) for(int i=0,_a=(a); i<_a; i++)
#define FORN(i,a,b) for(int i=(a),_b=(b);i<_b;i++)
#define DOWN(i,a,b) for(int i=a,_b=(b);i>=_b;i--)
#define SET(a,v) memset(a,v,sizeof(a))
#define sqr(x) ((x)*(x))
#define ll long long
#define F first
#define S second
#define PB push_back
#define MP make_pair

#define DEBUG(x) cout << #x << " = "; cout << x << endl;
#define PR(a,n) cout << #a << " = "; FOR(_,1,n) cout << a[_] << ' '; cout << endl;
#define PR0(a,n) cout << #a << " = "; REP(_,n) cout << a[_] << ' '; cout << endl;
using namespace std;

//Buffer reading
int INP,AM,REACHEOF;
const int BUFSIZE = (1<<12) + 17;
char BUF[BUFSIZE+1], *inp=BUF;
#define GETCHAR(INP) { \
    if(!*inp && !REACHEOF) { \
        memset(BUF,0,sizeof BUF);\
        int inpzzz = fread(BUF,1,BUFSIZE,stdin);\
        if (inpzzz != BUFSIZE) REACHEOF = true;\
        inp=BUF; \
    } \
    INP=*inp++; \
}
#define DIG(a) (((a)>='0')&&((a)<='9'))
#define GN(j) { \
    AM=0;\
    GETCHAR(INP); while(!DIG(INP) && INP!='-') GETCHAR(INP);\
    if (INP=='-') {AM=1;GETCHAR(INP);} \
    j=INP-'0'; GETCHAR(INP); \
    while(DIG(INP)){j=10*j+(INP-'0');GETCHAR(INP);} \
    if (AM) j=-j;\
}
//End of buffer reading

const long double PI = acos((long double) -1.0);
const int MN = 100111;

int na, nb, nc, a[MN], b[MN], c[MN], ina[MN], inb[MN], inc[MN], has[MN];
int sa, sb, sc, res;

void solve(int l, int r) {
    if (l > r) return ;

    if (r - l + 1 < res) return ;

    int good = 0;
    FOR(i,l,r) {
        ++has[c[i]];
        if (has[c[i]] == ina[c[i]]) ++good;
    }

    if (good == sa) res = r - l + 1;

    FOR(i,l,r) --has[c[i]];
}

int main() {
    while (scanf("%d%d%d", &na, &nb, &nc) == 3) {
        res = 0;
        memset(ina, 0, sizeof ina);
        memset(inb, 0, sizeof inb);
        memset(inc, 0, sizeof inc);

        FOR(i,1,na) {
            scanf("%d", &a[i]);
            if (!ina[a[i]]) ++sa;
            ina[a[i]]++;
        }
        FOR(i,1,nb) {
            scanf("%d", &b[i]);
            if (!inb[b[i]]) ++sb;
            inb[b[i]]++;
        }
        FOR(i,1,nc) {
            scanf("%d", &c[i]);
            if (!inc[c[i]]) ++sc;
            inc[c[i]]++;
        }

        int lastb = 0;
        FOR(i,1,nc)
        if (inb[c[i]]) {
            solve(lastb+1, i-1);
            lastb = i;
        }
        solve(lastb+1, nc);
        cout << res << endl;
    }
    return 0;
}
